#include <mpi.h>
#include <iostream>

using namespace std;

int main(int argc, char** argv) {
	// Initialize the MPI environment
	MPI_Init(&argc, &argv);

	// What is my rank (process ID).
	int world_rank;
	MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);

	// How many processes do we have in total?
	int world_size;
	MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	int err_code;
	int ranks[world_size];
	if ((err_code = MPI_Gather(&world_rank, 1, MPI_INT, ranks, 1, MPI_INT, 0, MPI_COMM_WORLD)) != MPI_SUCCESS)	{
		char err_msg[1024];
		int msg_length, err_class;
		MPI_Error_class(err_code, &err_class);
		MPI_Error_string(err_class, err_msg , &msg_length);
		cerr<<world_rank<<": "<<err_msg<<endl;
		MPI_Error_string(err_code, err_msg , &msg_length);
		cerr<<world_rank<<": "<<err_msg<<endl;
	} else if (world_rank == 0)	{
		for (int i = 0; i < world_size; ++i)
			cout<<" "<<ranks[i];
		cout<<endl;
	}

	// Always call at the end
	MPI_Finalize();

	return 0;
}

