#!/bin/bash
#PBS -S /bin/bash
#PBS -N mpitest
#PBS -l walltime=00:01:00
#PBS -l place=scatter:group=cluster
#PBS -l select=3:ncpus=2:mpiprocs=2:mem=100mb:scratch_local=10mb

DATADIR="$PBS_O_WORKDIR"

# setup SCRATCH cleaning in case of an error
trap 'clean_scratch' TERM EXIT
# enters user's scratch directory
cd $SCRATCHDIR || exit 1

# Initialize the module system.
source /software/modules/init
module load gcc-7.2.0
module load openmpi-2.1.1-gcc

# Copy sources and the input data of the program.
cp $DATADIR/mpitest.cpp .
mpic++ -o mpitest mpitest.cpp

# starts the application
cat $PBS_NODEFILE
echo -e "\nMpi test started..."
mpirun -machinefile $PBS_NODEFILE mpitest
echo -e "\nMpi test ended..."

