#!/bin/bash
#PBS -S /bin/bash
#PBS -N trigsimd
#PBS -l walltime=00:01:00
#PBS -l select=1:ncpus=4:mem=100mb:scratch_local=10mb:vnode=phi4

DATADIR="$PBS_O_WORKDIR"
cp $DATADIR/trigsimd.cpp $SCRATCHDIR
cp $DATADIR/trig_input.txt $SCRATCHDIR
cd $SCRATCHDIR || exit 1

source /software/modules/init
module load intelcdk-17.1

echo -e "CPU INFO\n"
cat /proc/cpuinfo

echo -e "\nCOMPILATION\n"

icpc -fopenmp -O3 -march=native -std=c++11 -qopt-report=1 -qopt-report-file:stdout -qopt-report-phase=vec -o trigsimd trigsimd.cpp
echo "Version of GLIBC"
ldd --version

echo -e "\nBenchmark started..."

export OMP_NUM_THREADS=$PBS_NUM_PPN
cat trig_input.txt | ./trigsimd

echo "Benchmark finished..."

